Package ec.breed

# Class GenerationSwitchPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.breed.GenerationSwitchPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class GenerationSwitchPipeline extends BreedingPipeline
GenerationSwitchPipeline is a simple BreedingPipeline which switches its source depending on the generation. If the generation number is invalid input: '<' n, then GenerationSwitchPipeline uses source.0. If the generation number if >= n, then GenerationSwitchPipeline uses source.1.

Important Note: Because GenerationSwitchPipeline gets the generation number from the EvolutionState, and this number is not protected by a mutex, if you create an EvolutionState or Breeder which uses multiple threads that can update the generation number as they like, you could cause a race condition. This doesn't occur with the present EvolutionState objects provided with ECJ, but you should be aware of the possibility.

Typical Number of Individuals Produced Per `produce(...)` call
Defined as the max of its children's responses.

Number of Sources
2

Parameters

base.`generate-max` bool = `true` (default) or `false` | (Each time produce(...) is called, should the GenerationSwitchPipeline force all its sources to produce exactly the same number of individuals as the largest typical number of individuals produced by any source in the group?)
base.`switch-at` int >= 0 | (The generation we will switch at)

Default Base
breed.generation-switch

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `boolean`
  `generateMax`
  `int`
  `generationSwitch`
  `int`
  `maxGeneratable`
  `static final int`
  `NUM_SOURCES`
  `static final String`
  `P_GEN_MAX`
  `static final String`
  `P_MULTIBREED`
  `static final String`
  `P_SWITCHAT`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GenerationSwitchPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `int`
  `typicalIndsProduced()`
  Returns the max of typicalIndsProduced() of all its children

  ### Methods inherited from class ec.BreedingPipeline

  `clone, fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, produces, sourcesAreProperForm`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_SWITCHAT

    public static final String P_SWITCHAT
    See Also:
      - Constant Field Values

  - ### P_MULTIBREED

    public static final String P_MULTIBREED
    See Also:
      - Constant Field Values

  - ### P_GEN_MAX

    public static final String P_GEN_MAX
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

  - ### maxGeneratable

    public int maxGeneratable

  - ### generateMax

    public boolean generateMax

  - ### generationSwitch

    public int generationSwitch

- ## Constructor Details

  - ### GenerationSwitchPipeline

    public GenerationSwitchPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### typicalIndsProduced

    public int typicalIndsProduced()
    Returns the max of typicalIndsProduced() of all its children
    Overrides:
      `typicalIndsProduced` in class `BreedingPipeline`

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`